/**
 * @overview Flexible generator, which makes your project clean and maintainable.
 * @version 7.0.19
 * @module coz
 * @author {@link http://okunishitaka.com|Taka Okunishi}
 * @license {@link MIT|}
 * @borrows module:coz~Coz#render as render
 * @borrows module:coz~Coz#clean as clean
 * @see https://github.com/coz-labo/coz
 * @requires {@link https://www.npmjs.org/package/aglob|aglob@^3.0.1}
 * @requires {@link https://www.npmjs.org/package/argx|argx@^4.0.0}
 * @requires {@link https://www.npmjs.org/package/arrayfilter|arrayfilter@^1.1.2}
 * @requires {@link https://www.npmjs.org/package/arraysort|arraysort@^2.0.0}
 * @requires {@link https://www.npmjs.org/package/commander|commander@^2.19.0}
 * @requires {@link https://www.npmjs.org/package/coz-bud|coz-bud@^5.0.1}
 * @requires {@link https://www.npmjs.org/package/coz-bud-compiler|coz-bud-compiler@^3.0.4}
 * @requires {@link https://www.npmjs.org/package/coz-bud-loader|coz-bud-loader@^3.0.3}
 * @requires {@link https://www.npmjs.org/package/coz-bud-remover|coz-bud-remover@^3.0.3}
 * @requires {@link https://www.npmjs.org/package/coz-bud-writer|coz-bud-writer@^3.0.1}
 * @requires {@link https://www.npmjs.org/package/coz-engine|coz-engine@^3.0.0}
 * @requires {@link https://www.npmjs.org/package/coz-handlebars-engine|coz-handlebars-engine@^4.0.1}
 * @requires {@link https://www.npmjs.org/package/coz-logger|coz-logger@^5.0.4}
 * @requires {@link https://www.npmjs.org/package/fmtjson|fmtjson@^4.0.3}
 */

'use strict'

const Coz = require('./coz')
const create = require('./create')

const coz = create({})
coz.create = create
coz.Coz = Coz
coz.version = '7.0.19'
coz.GENERATE_COMMENT = `// Code generated by coz ${coz.version} - DO NOT EDIT`

module.exports = coz
